package org.jeecg.modules.stm.rate.controller;

import java.util.Arrays;
import java.util.Date;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rate.entity.RateRule;
import org.jeecg.modules.stm.rate.service.IRateRuleService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 评分规则
 * @Author: jeecg-boot
 * @Date:   2023-09-18
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/rate/rateRule")
@Slf4j
public class RateRuleController extends JeecgController<RateRule, IRateRuleService> {
	@Autowired
	private IRateRuleService rateRuleService;
	
	/**
	 * 分页列表查询
	 *
	 * @param rateRule
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "评分规则-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<RateRule>> queryPageList(RateRule rateRule,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RateRule> queryWrapper = QueryGenerator.initQueryWrapper(rateRule, req.getParameterMap());
		Page<RateRule> page = new Page<RateRule>(pageNo, pageSize);
		IPage<RateRule> pageList = rateRuleService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param rateRule
	 * @return
	 */
	@AutoLog(value = "评分规则-添加")
	  
	@RequiresPermissions("rate:rate_rule:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RateRule rateRule) {
		rateRule.setUpdateTime(new Date());
		rateRule.setScore(new Double(100d));
		rateRuleService.save(rateRule);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param rateRule
	 * @return
	 */
	@AutoLog(value = "评分规则-编辑")
	  
	@RequiresPermissions("rate:rate_rule:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RateRule rateRule) {
		rateRuleService.updateById(rateRule);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "评分规则-通过id删除")
	  
	@RequiresPermissions("rate:rate_rule:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		rateRuleService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "评分规则-批量删除")
	  
	@RequiresPermissions("rate:rate_rule:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.rateRuleService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "评分规则-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<RateRule> queryById(@RequestParam(name="id",required=true) String id) {
		RateRule rateRule = rateRuleService.getById(id);
		if(rateRule==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(rateRule);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param rateRule
    */
    @RequiresPermissions("rate:rate_rule:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RateRule rateRule) {
        return super.exportXls(request, rateRule, RateRule.class, "评分规则");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("rate:rate_rule:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RateRule.class);
    }

}
